//AppliquerCanalAlpha_201f.js
// 25.01.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Appliquer un canal Alpha

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention", true);
	exit();
}

// mmoriser la slection...
var curSel = app.selection;
var nItems = curSel.length;
// ... et la tester
if (nItems == 0) {
	alert ("Il n'y a pas de slection.", "Stop", true);
	exit();
}
// vrifier si l'objet slectionn est un bloc image ou une image
// et mmoriser le chemin au fichier image
var objType = curSel[0].constructor.name;
if (objType == "Rectangle" || objType == "Polygon" || objType == "Oval") {
	try {
		var curObj = curSel[0].images[0];
		var curLink = curObj.itemLink;
		var curPath = curLink.filePath;
	}
	catch (e) {
		alert ("Le bloc image est vide.", "Stop", true);
		exit();
	}
}
else if (objType == "Image") {
	var curObj = curSel[0];
	var curLink = curObj.itemLink;
	var curPath = curLink.filePath;
}
else {
	alert ("Il faut slectionner une image.", "Attention", true);
	exit();
}
// mmoriser l'tat du lien...
var curStatus = curLink.status*1;
// ... et le tester
if (curStatus == 1819109747) {
	alert ("Le fichier image n'existe pas.", "Stop", true);
	exit();
}
else if (curStatus == 1819242340) {
	alert ("Il faut actualiser le lien.", "Attention", true);
	exit();
}
// dresser une liste des canaux Alpha
var alphaNames = curObj.clippingPath.alphaChannelPathNames;
// vrifier le nombre des canaux Alpha
if (alphaNames.length == 0) {
	alert ("L'image ne contient pas de canal Alpha.", "Stop", true);
	exit();
}
// supprimer des dialogues ventuels de la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}
// prparer le dialogue...
var aDialog = app.dialogs.add({name:"Slectioner le canal Alpha:"});
with (aDialog) {
	with (dialogColumns.add()) {
		var alphaDrop = dropdowns.add({stringList:alphaNames, selectedIndex:0});
	}
}
// ... et l'afficher
if (aDialog.show() == true) {
	// mmoriser l'article slectionn
	var curAlpha = alphaNames[alphaDrop.selectedIndex];
	// supprimer le dialogue de la mmoire
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}
// rgler les prfrences
app.imageIOPreferences.alphaChannelName = curAlpha;
// importer l'image
curSel[0].place(File(curPath));